import { Map, Set } from "immutable";
import { TypeAttributeKind, TypeAttributes } from "./TypeAttributes";
import { EnumType, ClassType, UnionType, Type } from "./Type";
export declare type AccessorEntry = string | {
    [language: string]: string;
};
export declare type AccessorNames = {
    [key: string]: AccessorEntry;
};
export declare const accessorNamesTypeAttributeKind: TypeAttributeKind<AccessorNames>;
export declare function isAccessorEntry(x: any): x is AccessorEntry;
export declare function checkAccessorNames(x: any): AccessorNames;
export declare function classPropertyNames(c: ClassType, language: string): Map<string, [string, boolean] | undefined>;
export declare function enumCaseNames(e: EnumType, language: string): Map<string, [string, boolean] | undefined>;
export declare function getAccessorName(names: Map<string, [string, boolean] | undefined>, original: string): [string | undefined, boolean];
export declare const unionIdentifierTypeAttributeKind: TypeAttributeKind<Set<number>>;
export declare function makeUnionIdentifierAttribute(): TypeAttributes;
export declare const unionMemberNamesTypeAttributeKind: TypeAttributeKind<Map<number, AccessorEntry>>;
export declare function makeUnionMemberNamesAttribute(unionAttributes: TypeAttributes, entry: AccessorEntry): TypeAttributes;
export declare function unionMemberName(u: UnionType, member: Type, language: string): [string | undefined, boolean];
